#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>

#define TASKNAME "lcs"

const int MaxN = 103;

bool g [MaxN] [MaxN];
int f [MaxN] [MaxN];
int x [MaxN] [MaxN];
int y [MaxN] [MaxN];
int a [MaxN];
int b [MaxN];
int ans1 [MaxN];
int ans2 [MaxN];
int l, m, n;

int main (void)
{
 int i, j, k, i2, j2;
 char ch;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 while (scanf (" %d %d %d", &m, &n, &l) != EOF)
 {
  assert (m >= 1 && m <= 100);
  assert (n >= 1 && n <= 100);
  assert (l >= 0 && l <= 676);
  for (i = 0; i < m; i++)
  {
   scanf (" %c", &ch);
   assert (ch >= 'a' && ch <= 'z');
   a[i] = ch - 'a';
  }
  a[m] = 'z' - 'a' + 1;
  for (j = 0; j < n; j++)
  {
   scanf (" %c", &ch);
   assert (ch >= 'a' && ch <= 'z');
   b[j] = ch - 'a';
  }
  b[n] = 'z' - 'a' + 1;

  memset (g, 0, sizeof (g));
  for (i = 0; i < l; i++)
  {
   scanf (" %c", &ch);
   assert (ch >= 'a' && ch <= 'z');
   j = ch - 'a';
   scanf (" %c", &ch);
   assert (ch >= 'a' && ch <= 'z');
   k = ch - 'a';
   g[j][k] = true;
  }

  memset (f, -63, sizeof (f));
  f[0][0] = 0;
  for (i = 0; i <= m; i++)
   for (j = 0; j <= n; j++)
   {
    if (f[i + 1][j] < f[i][j])
     f[i + 1][j] = f[i][j],
     x[i + 1][j] = i,
     y[i + 1][j] = j;
    if (f[i][j + 1] < f[i][j])
     f[i][j + 1] = f[i][j],
     x[i][j + 1] = i,
     y[i][j + 1] = j;
    if (g[a[i]][b[j]])
     if (f[i + 1][j + 1] < f[i][j] + 1)
      f[i + 1][j + 1] = f[i][j] + 1,
      x[i + 1][j + 1] = i,
      y[i + 1][j + 1] = j;
   }
  k = 0;
  i = m;
  j = n;
  while (i + j > 0)
  {
   i2 = x[i][j];
   j2 = y[i][j];
   if (f[i][j] > f[i2][j2])
   {
    ans1[k] = i;
    ans2[k] = j;
    k++;
   }
   i = i2;
   j = j2;
  }
  assert (k == f[m][n]);
  printf ("%d\n", k);
  for (i = 0; i < k; i++)
   printf ("%d%c", ans1[k - i - 1], i + 1 < k ? ' ' : '\n');
  for (i = 0; i < k; i++)
   printf ("%d%c", ans2[k - i - 1], i + 1 < k ? ' ' : '\n');
 }
 return 0;
}
