#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>

#define TASKNAME "bishop"

const int MinN = 1, MaxN = 8, MaxD = 2;
const int dx [MaxD] = {-1, -1},
          dy [MaxD] = {-1,  1};

int main (void)
{
 char b, c;
 int d, e, x0, y0, x, y;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 while (scanf (" %c %c", &b, &c) != EOF)
 {
  x0 = b - 'a' + 1;
  y0 = c - '1' + 1;
  assert (x0 >= MinN && x0 <= MaxN);
  assert (y0 >= MinN && y0 <= MaxN);
  for (d = 0; d < MaxD; d++)
  {
   for (e = -MaxN + 1; e < MaxN - 1; e++) if (e)
   {
    x = x0 + dx[d] * e;
    y = y0 + dy[d] * e;
    if (x < MinN || x > MaxN) continue;
    if (y < MinN || y > MaxN) continue;
    printf ("%c%c\n", x + 'a' - 1, y + '1' - 1);
   }
  }
 }
 return 0;
}
