#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>

#define TASKNAME "bishop"
enum {OK, WA, PE, JE, NUM};
const char err [NUM] [NUM] = {"OK", "WA", "PE", "JE"};
const int MaxBuf = 65536;
typedef unsigned long long uint64;

FILE * fin, * fout, * fans;

void chkexit (const char * msg, int code)
{
 fprintf (stdout, "%s: %s\n", err[code], msg);
 exit (code);
}

uint64 answer (FILE * f, int mask)
{
 char buf [MaxBuf];
 int l;
 uint64 res, coord;
 res = 0ull;
 while (fgets (buf, sizeof (buf), f) != NULL)
 {
  l = strlen (buf);
  if (buf[l - 1] == '\n')
  {
   buf[l - 1] = '0';
   l--;
  }
  if (l != 2)
   chkexit ("String size is incorrect!", PE | mask);
  coord = ((buf[0] - 'a') << 3) + (buf[1] - '1');
  if (res & (1ull << coord))
   chkexit ("Duplicate line!", WA | mask);
  res |= (1ull << coord);
 }
 return res;
}

int main (int argc, char * argv [])
{
 uint64 res1, res2;
 assert (argc >= 4);
 if ((fin = fopen (argv[1], "r")) == NULL) chkexit ("No input file!", JE);
 if ((fout = fopen (argv[2], "r")) == NULL) chkexit ("No output file!", PE);
 if ((fans = fopen (argv[3], "r")) == NULL) chkexit ("No answer file!", JE);

 res1 = answer (fout, OK);
 res2 = answer (fans, JE);
 if (res1 == res2)
  chkexit ("Equal answers were given.", OK);
 else
  chkexit ("Answer does not match!", WA);
 return 0;
}
