#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>

#define TASKNAME "bishop"

const int MinN = 1, MaxN = 8, MaxD = 4;
const int dx [MaxD] = {-1, -1,  1,  1},
          dy [MaxD] = {-1,  1,  1, -1};

int main (void)
{
 char b, c;
 int d, x0, y0, x, y;
 bool nl;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 nl = false;
 while (scanf (" %c %c", &b, &c) != EOF)
 {
  if (!nl) nl = true;
  else printf ("\n");
  x0 = b - 'a' + 1;
  y0 = c - '1' + 1;
  assert (x0 >= MinN && x0 <= MaxN);
  assert (y0 >= MinN && y0 <= MaxN);
  for (d = 0; d < MaxD; d++)
  {
   x = x0;
   y = y0;
   while (1)
   {
    x += dx[d];
    y += dy[d];
    if (x < MinN || x > MaxN) break;
    if (y < MinN || y > MaxN) break;
    printf ("%c%c\n", x + 'a' - 1, y + '1' - 1);
   }
  }
 }
 return 0;
}
